; Different colors for different file extensions

; This is just a small piece of E code that I find extremely useful.
; Everything between the dotted lines goes into a file called MySelect.E.
; This file is automatically (try)included when etpm-ing epm.
;
; To use - Put everything into MySelect.E, and ETPM EPM.
; You WOULD like to change the colors and add more extensions.
; This is done by changing the SetExtColor lines below the definit.
; You may use all the colors defined in Colors.E.

; Amir Kolsky

compile if not defined(Yellow)
  include    'colors.e' -- Mnemonic color names & default colors defined here.
compile endif

defproc SetExtColor(aid, ext, clr)
  do_array 2, aid, ext, clr

definit
  do_array 1, aId, "Extension Color"
  SetExtColor(aId, 'C', Black + YellowB)
  SetExtColor(aId, 'RC', Blue + YellowB)
  SetExtColor(aId, 'H', Black + Light_GreyB)
  SetExtColor(aId, 'E', Blue + Light_GreyB)

defselect
  do_array 6, aId, "Extension Color"
  display -2
  do_array 3, aId, filetype(), Clr
  display 2
  if (Clr = '') then
    Clr = Black + WhiteB
  endif
  .textcolor = clr
