; I like to use pad-plus as a newline key.  Unfortunately, we can't
; distinguish it in EPM since we use the ASCII codes, and PM doesn't
; distinguish between the pad keys and the main-keyboard keys.  The
; following uses the shift status to determine which is which - if
; the shift key isn't depressed when we see the '+', it must be on the
; numeric keypad (at least, for the U.S. keyboard.  If the '+' key is
; unshifted on the main keyboard for your country, then this will not
; be useful to you.)

; By Larry Margolis

 compile if EPM
def '+' =
   ks = getkeystate(9)
;  sayerror 'shift_state =' ks
   if ks=3 or ks=4 then  -- Unshifted; must be pad plus
      down; begin_line
   else                  -- Shifted, must be regular plus.
      keyin '+'
   endif

 compile else

def padplus=down; begin_line
 compile endif
